var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentMethod, VegaSlimmer } from 'vega-slimmer/core';
import KeyboardManager from '../keyboard/keyboard-manager';
export class KeyboardManagerSlimmer extends VegaSlimmer {
  constructor(listenersRetriever) {
    super();
    this.keyboardEventListeners = [];
    this.listenersRetriever = listenersRetriever;
  }
  connectedCallback() {
    KeyboardManager.register(this.keyboardEventListeners);
  }
  disconnectedCallback() {
    KeyboardManager.deregister(this.keyboardEventListeners);
  }
  componentDidLoad() {
    this.keyboardEventListeners = this.listenersRetriever(this);
    KeyboardManager.register(this.keyboardEventListeners);
  }
}
__decorate([
  MapToComponentMethod('connectedCallback')
], KeyboardManagerSlimmer.prototype, "connectedCallback", null);
__decorate([
  MapToComponentMethod('disconnectedCallback')
], KeyboardManagerSlimmer.prototype, "disconnectedCallback", null);
__decorate([
  MapToComponentMethod('componentDidLoad')
], KeyboardManagerSlimmer.prototype, "componentDidLoad", null);
